"use strict";
var commander = require('commander');
var fs = require('fs');
var size_tree = require('./size_tree');
function printStats(json) {
    var bundleStats = JSON.parse(json);
    var depTrees = size_tree.dependencySizeTree(bundleStats);
    depTrees.forEach(function (tree) { return size_tree.printDependencySizeTree(tree); });
}
commander.version('1.1.0')
    .usage('[options] [Webpack JSON output]')
    .description("Analyzes the JSON output from 'webpack --json'\n  and displays the total size of JS modules\n  contributed by each NPM package that has been included in the bundle.\n \n  The JSON output can either be supplied as the first argument or\n  passed via stdin.\n  ");
commander.parse(process.argv);
if (commander.args[0]) {
    printStats(fs.readFileSync(commander.args[0]).toString());
}
else if (!process.stdin.isTTY) {
    var json_1 = '';
    process.stdin.on('data', function (chunk) { return json_1 += chunk.toString(); });
    process.stdin.on('end', function () { return printStats(json_1); });
}
else {
    console.error('No Webpack JSON output file specified. Use `webpack --json` to generate it.');
    process.exit(1);
}
